//=============================================================================
// DSP281x EVM Test Program
//
// by nexp76(nexp76@naver.com)	
// http://cafe.naver.com/elab.cafe
// [timer1.h]
//=============================================================================

#include "..\00_hal\system.h"


/*
 - DSP281x EVM Onboard Led Test Program
  LED1 ---> GPIOF13 
  LED2 ---> GPIOF12


 -SystemInit() 
  -DSP281x Ŭ  ͷƮ ʱȭ 
  - ⺻ ʱȭ Ǿ ϴ ƾ     ֵ 
  
 - LED toggle example 
 
 - CPU Timer0 ̿ LEḎ..
  - InitTimer0() Ÿ̸ ʱȭ Լ
  - SetTimer0() ͷƮ ֱ  Լ
*/


//-----------------------------------------------------------------------------
// LED Driver - HAL Part
//-----------------------------------------------------------------------------
#define Led1On()						(GpioDataRegs.GPFDAT.bit.GPIOF13 = 0)
#define Led1Off()						(GpioDataRegs.GPFDAT.bit.GPIOF13 = 1)
#define Led1Toggle()					(GpioDataRegs.GPFDAT.bit.GPIOF13 ^= 1)

#define Led2On()						(GpioDataRegs.GPFDAT.bit.GPIOF12 = 0)
#define Led2Off()						(GpioDataRegs.GPFDAT.bit.GPIOF12 = 1)
#define Led2Toggle()					(GpioDataRegs.GPFDAT.bit.GPIOF12 ^= 1)


void Init_Led(void)
{
    EALLOW;
	//sets GPIO Muxs as I/Os 
    GpioMuxRegs.GPFMUX.bit.MDXA_GPIOF12 = 0;
    GpioMuxRegs.GPFMUX.bit.MDRA_GPIOF13 = 0;
										
	// DIR select GPIOs as output 
    GpioMuxRegs.GPFDIR.bit.GPIOF12=1;
    GpioMuxRegs.GPFDIR.bit.GPIOF13=1;
    EDIS;
} 
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
// TIMER0
#define MAIN_CLK_100MHZ						100
#define SetTimer0(TimeTickUs)    						ConfigCpuTimer(&CpuTimer0, MAIN_CLK_100MHZ, TimeTickUs)
void cpu_timer0_isr(void);


void InitTimer0(void)
{
// Interrupts that are used in this example are re-mapped to
// ISR functions found within this file.  
   EALLOW;  // This is needed to write to EALLOW protected registers
   PieVectTable.TINT0 = &cpu_timer0_isr;
   EDIS;    // This is needed to disable write to EALLOW protected registers

// This function is found in DSP281x_InitPeripherals.c
// InitPeripherals(); // Not required for this example
   InitCpuTimers();   // For this example, only initialize the Cpu Timers

// Enable CPU INT1 which is connected to CPU-Timer 0:
   IER |= M_INT1;

// Enable TINT0 in the PIE: Group 1 interrupt 7
   PieCtrlRegs.PIEIER1.bit.INTx7 = 1;

// Enable global Interrupts and higher priority real-time debug events:
   ERTM;   // Enable Global realtime interrupt DBGM
}

interrupt void cpu_timer0_isr(void)
{
	//----------------------------------------------
	//Timer Interrupt Handler	
	CpuTimer0.InterruptCount++;

	//LED Toggle
	Led1Toggle();
	Led2Toggle();
	//----------------------------------------------
		
	// Acknowledge this interrupt to receive more interrupts from group 1
	PieCtrlRegs.PIEACK.all = PIEACK_GROUP1;
}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Main Routine
//-----------------------------------------------------------------------------
void main(void)
{
	//System Initialize
	SystemInit();

	//LED initiazle
	Init_Led();
	Led2On();
	Led1On();

	//Initialize Timer
	InitTimer0();

	//Configure CPU-Timer 0 to interrupt every second:
	//100MHz CPU Freq, 100ms second Period (in uSeconds)
	SetTimer0(100000);
   	StartCpuTimer0();

   	//Enable Global interrupt INTM
	enable();   

	while(1)
	{

	}
} 	
//-----------------------------------------------------------------------------